osl::checkmate::DfpnPathList Struct Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Types | Public Member Functions | Static Public Member Functions | Private Member Functions | List of all members
osl::checkmate::DfpnPathList Struct Reference
Inheritance diagram for osl::checkmate::DfpnPathList:
[legend]
Collaboration diagram for osl::checkmate::DfpnPathList:
[legend]

## Public Types
typedef slist< std::pair < PieceStand, DfpnPathRecord > > | list_t

## Public Member Functions
template<Player Attack>
DfpnPathRecord * | allocate (PieceStand black, int depth, LoopToDominance &loop, size_t &size)
const DfpnPathRecord * | probe (PieceStand black) const
size_t | runGC (size_t threshold)

## Static Public Member Functions
static bool | precious (const DfpnPathRecord &record, size_t threshold)

## Private Member Functions
template<Player Attack>
iterator | find (PieceStand black, LoopToDominance &loop)

## Detailed Description

Definition at line 190 of file dfpn.cc.

## Member Typedef Documentation

typedef slist<std::pair<PieceStand, DfpnPathRecord> > osl::checkmate::DfpnPathList::list_t

Definition at line 196 of file dfpn.cc.

## Member Function Documentation

template<Player Attack>

DfpnPathRecord* osl::checkmate::DfpnPathList::allocate | ( | PieceStand | black,
|  | int | depth,
|  | LoopToDominance & | loop,
|  | size_t & | size
| ) |  |
| inline

Definition at line 228 of file dfpn.cc.

References depth, osl::checkmate::DfpnPathRecord::distance, osl::checkmate::DfpnPathRecord::MaxDistance, and osl::eval::min().

Referenced by osl::checkmate::DfpnPathTable::allocate().

template<Player Attack>

iterator osl::checkmate::DfpnPathList::find | ( | PieceStand | black,
|  | LoopToDominance & | loop
| ) |  |
| inlineprivate

Definition at line 199 of file dfpn.cc.

References osl::checkmate::BadAttackLoop, osl::BLACK, osl::PieceStand::isSuperiorOrEqualTo(), osl::checkmate::DfpnPathRecord::MaxDistance, osl::checkmate::NoLoop, and osl::WHITE.

static bool osl::checkmate::DfpnPathList::precious | ( | const DfpnPathRecord & | record,
|  | size_t | threshold
| ) |  |
| inlinestatic

Definition at line 251 of file dfpn.cc.

References osl::checkmate::DfpnPathRecord::node_count, osl::checkmate::DfpnPathRecord::twin_list, and osl::checkmate::DfpnPathRecord::visiting.

Referenced by runGC().

const DfpnPathRecord* osl::checkmate::DfpnPathList::probe | ( | PieceStand | black) |  | const
| inline

Definition at line 243 of file dfpn.cc.

size_t osl::checkmate::DfpnPathList::runGC | ( | size_t | threshold) |  |
| inline

Definition at line 257 of file dfpn.cc.

References precious().

The documentation for this struct was generated from the following file:

- dfpn.cc